

#include "constants.h"
#include "calculate.h"

double arg(double x,double y)
{
 if (x == 0.0)
	{
	 if (y >0.0) return HALF_PI ; else return - HALF_PI ;
	}
 if (x > 0.0) return atan(y/x) ; else return atan(y/x) + PII ;
}


void calculateNoneEffect(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V1(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = sin(ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5]) ;
		 x0  = cos(tmp) ;

		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = sin(ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5]) ;
		 x0  = cos(tmp) ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V2(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = y0*y0+tmp*tmp+1e-10 ;
		 x1 = 1.0/x1 ;
		 y0 = y0*x1  ;
		 x0 = tmp*x1 ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = y0*y0+tmp*tmp+1e-10 ;
		 x1 = 1.0/x1 ;
		 y0 = y0*x1 ;
		 x0 = tmp*x1 ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}


void calculate_V3(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  =ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5]  ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = x1 * cos(x1+y1) ;
		 y0 = x1 * sin(x1+y1) ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = x1 * cos(x1+y1) ;
		 y0 = x1 * sin(x1+y1) ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V4(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 y1 += y1 ;
		 x0 = x1 * cos(y1) ;
		 y0 = x1 * sin(y1) ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 y1 += y1 ;
		 //y1 = arg(tmp,y0) ;
		 x0 = x1 * cos(y1) ;
		 y0 = x1 * sin(y1) ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V5(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = y1 * INV_PI ;
		 y0 = x1 - 1.0 ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 y1 = arg(tmp,y0) ;
		 x0 = y1 * INV_PI ;
		 y0 = x1 - 1.0 ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V6(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = x1*sin(x1+y1) ;
		 y0 = x1*cos(y1-x1) ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = x1*sin(x1+y1) ;
		 y0 = x1*cos(y1-x1) ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V7(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = x1*sin(x1*y1) ;
		 y0 = -x1*cos(y1*x1) ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = x1*sin(x1*y1) ;
		 y0 = -x1*cos(y1*x1) ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V8(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) * INV_PI ; else y1 = 0.5 ;
		 //y1 = arg(tmp,y0) * INV_PI ;
		 x0 = y1 * sin(PII*x1) ;
		 y0 = y1 * cos(PII*x1) ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) * INV_PI ; else y1 = 0.5 ;
		 //y1 = arg(tmp,y0) * INV_PI ;
		 x0 = y1 * sin(PII*x1) ;
		 y0 = y1 * cos(PII*x1) ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V9(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp+1e-10) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = cos(y1) + sin(x1) ;
		 y0 = sin(y1) - cos(x1) ;
		 x1 = 1.0 / x1 ;
		 x0 *= x1 ;
		 y0 *= x1 ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp+1e-10) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = cos(y1) + sin(x1) ;
		 y0 = sin(y1) - cos(x1) ;
		 x1 = 1.0 / x1 ;
		 x0 *= x1 ;
		 y0 *= x1 ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V10(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp+1e-10) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = sin(y1)/x1 ;
		 y0 = cos(y1)*x1 ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = y0*y0+tmp*tmp+1e-10 ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = sin(y1)/x1 ;
		 y0 = cos(y1)*x1 ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V11(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = sin(y1)*cos(x1) ;
		 y0 = sin(x1)*cos(y1) ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = y0*y0+tmp*tmp+1e-10 ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 x0 = sin(y1)*cos(x1) ;
		 y0 = sin(x1)*cos(y1) ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V12(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,tmp2 ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 tmp = sin(x1+y1) ;
		 tmp2 = tmp * tmp ;
		 x0 = x1 * tmp2 * tmp ;
		 tmp = cos(y1-x1) ;
		 tmp2 = tmp * tmp ;
		 y0 = x1 * tmp2 * tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(y0*y0+tmp*tmp) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0) ;
		 tmp = sin(x1+y1) ;
		 tmp2 = tmp * tmp ;
		 x0 = x1 * tmp2 * tmp ;
		 tmp = cos(y1-x1) ;
		 tmp2 = tmp * tmp ;
		 y0 = x1 * tmp2 * tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_V13(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,tmp2 ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 tmp2 = rand() * irand * PII ;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(sqrt(y0*y0+tmp*tmp)) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0)*0.5 ;
		 x0 = x1 * cos(y1+tmp2) ;
		 y0 = x1 * sin(y1+tmp2) ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
		 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
		 x1 = sqrt(sqrt(y0*y0+tmp*tmp)) ;
		 if (tmp != 0.0) y1 = atan(y0/tmp) ; else y1 = HALF_PI ;
		 //y1 = arg(tmp,y0)*0.5 ;
		 x0 = x1 * cos(y1+tmp2) ;
		 y0 = x1 * sin(y1+tmp2) ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W1(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x0 = sin(x0) ;
		 y0 = sin(y0) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x0 = sin(x0) ;
		 y0 = sin(y0) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W2(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * cos(y1+x1*x1) ;
		 y0 = x1 * sin(y1+x1*x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * cos(y1+x1*x1) ;
		 y0 = x1 * sin(y1+x1*x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W3(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * cos(y1+x1) ;
		 y0 = x1 * sin(y1+x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * cos(y1+x1) ;
		 y0 = x1 * sin(y1+x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W4(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * cos(y1+y1) ;
		 y0 = x1 * sin(y1+y1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * cos(y1+y1) ;
		 y0 = x1 * sin(y1+y1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W5(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = y1 * INV_PI ;
		 y0 = x1  ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = y1 * INV_PI ;
		 y0 = x1 ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W6(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * sin(y1+x1) ;
		 y0 = x1 * cos(y1-x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * sin(y1+x1) ;
		 y0 = x1 * cos(y1-x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W7(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * sin(y1*x1) ;
		 y0 = x1 * cos(y1*x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * sin(y1*x1) ;
		 y0 = x1 * cos(y1*x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W8(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) * INV_PI ;
		 x0 =  y1 * sin(x1 * PII ) ;
		 y0 = y1 * cos(PII*x1)*x1 ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) * INV_PI ;
		 x0 = y1 * sin(x1 * PII) ;
		 y0 = y1 * cos(x1 * PII) * x1  ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W9(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * (cos(y1)+sin(x1)) ;
		 y0 = x1 * (sin(y1)-cos(x1)) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * (cos(y1)+sin(x1)) ;
		 y0 = x1 * (sin(y1)-cos(x1)) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W10(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * x1 * sin(y1) ;
		 y0 = x1 * cos(y1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = x1 * x1 * sin(y1) ;
		 y0 = x1 * cos(y1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W11(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = sin(y1)*cos(x1)*x1 ;
		 y0 = cos(y1)*sin(x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 x0 = sin(y1)*cos(x1)*x1 ;
		 y0 = cos(y1)*sin(x1) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W12(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika,tmp2 ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 tmp = sin(x1+y1) ;
		 tmp2 = tmp * tmp ;
		 x0 = x1 * tmp*tmp2 ;
		 tmp = cos(y1-x1) ;
		 tmp2 = tmp * tmp ;
		 y0 = x1 * tmp * tmp2 ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(x0*x0 + y0*y0) ;
		 y1 = arg(x0,y0) ;
		 tmp = sin(x1+y1) ;
		 tmp2 = tmp * tmp ;
		 x0 = x1 * tmp*tmp2 ;
		 tmp = cos(y1-x1) ;
		 tmp2 = tmp * tmp ;
		 y0 = x1 * tmp * tmp2 ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}

void calculate_W13(double xMin,double yMax,double dx,double dy,long iter,double* ifs,long sizeX,long* m,double ka)
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ,ika,tmp2 ;
 long i,j,k,kk,capp ;
 time_t rand_germe ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;
 ika = 1.0 / ka ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) m[j+i*sizeX] = 0 ;

 for(kk=0;kk<100;kk++)
	{
	 x0 = rand() * irand ;
	 y0 = rand() * irand ;
	 x0 = xMin+(-1.0+x0*3.0)*dX;
	 y0 = yMax-(-1.0+y0*3.0)*dY;
	 for(k=0;k<100;k++)
		{
		 happ = rand() * irand ;
		 tmp2 = rand() * irand * PII ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(sqrt(x0*x0 + y0*y0)) ;
		 y1 = arg(x0,y0)*0.5 ;
		 x0 = x1 * cos(y1+tmp2) ;
		 y0 = x1 * sin(y1+tmp2) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;
		}
	 for(k=0;k<iter;k++)
		{
		 happ = rand() * irand ;
		 capp = 0 ;
		 suite = ifs[capp+6] ;
		 while( happ > suite)
			{
			 capp += 10 ;
			 suite += ifs[capp+6] ;
			}

		 x0 = (x0 - ifs[capp+8]) * ka ;
		 y0 = (y0 - ifs[capp+9]) * ka ;
		 x1 = sqrt(sqrt(x0*x0 + y0*y0)) ;
		 y1 = arg(x0,y0)*0.5 ;
		 x0 = x1 * cos(y1+tmp2) ;
		 y0 = x1 * sin(y1+tmp2) ;
		 tmp = (ifs[capp] * x0 + ifs[capp+1] * y0) * ika + ifs[capp+8] ;
		 y0  = (ifs[capp+2] * x0 + ifs[capp+3] * y0) * ika + ifs[capp+9] ;
		 x0  = tmp ;

		 x1 = (x0-xMin)*coefx ;
		 y1 = (yMax-y0)*coefy ;
		 if (fabs(x1) + fabs(y1) > 1e5) break;
		 i = long(y1) ;
		 j = long(x1) ;
		 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX)) m[i*sizeX+j]++ ;
		}
	}
}






