#ifndef CONTENEURIMAGE_H
#define CONTENEURIMAGE_H

using namespace std ;

#include <iostream>
#include <cmath>

#include <qpainter.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qfiledialog.h>
#include <qmessagebox.h>


#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
//#include <qslider.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qscrollview.h>

#include "constants.h"


class fenetreImage ;
class QString ;

class conteneurImage : public QWidget
{
    Q_OBJECT

 public :
    conteneurImage();
    conteneurImage( QPixmap & s ) ;
    ~conteneurImage();
    void imageChanged(QPixmap* s) ;
    void saveIFS(QString) ;
    void loadIFS(QString) ;

 signals :
    void signalIFSchanged( paralleVector*,int,int ) ;
    void signalCalculate() ; 


 private slots :
    void slotIFSchanged( paralleVector* p,int,int) ;


 protected :
    virtual void resizeEvent(QResizeEvent* ) ;
    virtual void keyPressEvent( QKeyEvent* ) ;
    virtual void keyReleaseEvent( QKeyEvent* ) ;

 private :

    QScrollView* _scrollview ;
    fenetreImage* _fenetreImage ;
};

#endif

