#ifndef EFFECTCOLORRELIEF_H
#define EFFECTCOLORRELIEF_H

#include <qstring.h>
#include <qtextstream.h>

#include "effectColor.h"

class sparam ;
class effectColor ;
class planche ;

// classe abstraite pour reprsenter les attracteurs ou fractales
class effectColorRelief : public effectColor
{

 public :
  effectColorRelief() ;
  virtual ~effectColorRelief() ;
  virtual void setParameters(sparam* ) ;
  virtual void streamParameters( QTextStream& ) ;
  virtual void calculate(planche*) ;

 private :
  double intensity,theta,phi ;
  int typeZ ;
} ;

#endif
