#include "effectFunctionApophysis_12.h"
#include "sparam.h"
#include "planche.h"

effectFunctionApophysis_12 :: effectFunctionApophysis_12()
{
}

effectFunctionApophysis_12 :: ~effectFunctionApophysis_12()
{
}

void effectFunctionApophysis_12 :: setParameters(sparam* p)
{
}

void effectFunctionApophysis_12 :: streamParameters( QTextStream& st )
{
}

void effectFunctionApophysis_12 :: calculate(double* x0p,double* y0p,double* ifs,int capp,double x0,double y0)
{
 double t,th,t2,t3 ;

 x0 += ifs[capp+8] ;
 y0 += ifs[capp+9] ;
 t = sqrt( x0*x0+y0*y0) ;
 if (x0 != 0.0) th = atan(y0/x0) ; else  th = HALF_PI ;
 //cout << " void effectFunctionApophysis_12 :: calculate( planche* pl ) " << endl ;
 t2 = sin(t+th) ;
 t3 = t2 * t2 ;
 *x0p = t * t3 * t2 ;
 t2 = cos(th-t) ;
 t3 = t2 * t2 ;
 *y0p = t * t3 * t2 ;
}




