
//#include <iostream>
//#include <fstream>
using namespace std ;

#include <iostream>
#include <cmath>

//#include <iostream>
//#include <cmath>

#include <qapplication.h>
#include <qmenubar.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qpopupmenu.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qstring.h>
#include <qfiledialog.h>
//#include <qcolor.h>
#include <qlabel.h>
#include <qslider.h>
#include <qstatusbar.h>

#include <qtabwidget.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qtextedit.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qcombobox.h>
//#include <qframe.h>
#include <qlayout.h>
#include <qtooltip.h>
//#include <qdialog.h>


#include "constants.h"
#include "sparam.h"
#include "fenetrePrincipale.h"
#include "conteneurImage.h"
#include "conteneurPlanche.h"
//#include "planche.h"
#include "repartition.h"
//#include "qdoubleslider.h"
//#include "preferences.h"
#include "dialog3D.h"
#include "dialogAlgorithm.h"
#include "dialogPalette.h"
#include "wEffectColorGamma.h"
#include "wEffectColorRelief.h"
#include "wEffectColorLog.h"
#include "wEffectColorContrast.h"
#include "wEffectFunction.h"
#include "wEffectFunctionSlip.h"
#include "wEffectFunctionApophysisNew.h"

void fenetrePrincipale :: changePaletteForRepartition()
{
 paletteRGB* p ;

 p = _conteneurPlanche->getPalette() ;
 //cout << " p  = " << p << endl ;
 //cout << " nb = " << p->nbColors << endl ;
 _repartition->drawPalette(p) ;
}

fenetrePrincipale :: fenetrePrincipale()
{
 int i ;

 setCaption( "qifs-0.1.1" ) ;
 drawMatrixWithRepartitionColoration = false ;

 for(i=0;i<SIZE_IMAGE_REPARTITION_X;i++) repartitionZoom[i] = 0 ;
 _conteneurPlanche = new conteneurPlanche() ;
 _conteneurPlanche->setGeometry(0,0,514,514) ;
 _dialogPalette = new dialogPalette("palettes/","*.txt",this) ;

    setCentralWidget( new QWidget( this, "qt_central_widget" ) );

    tabWidget = new QTabWidget( centralWidget(), "tabWidget" );
    tabWidget->setGeometry( QRect( 10, 10, 280, 450 ) );


    _repartition = new repartition( tabWidget, "_repartition",0 );
    tabWidget->insertTab( _repartition, QString("") );
    _repartition->drawRepartition(repartitionZoom) ;
    changePaletteForRepartition() ;

    _frame = new QWidget( tabWidget, "_frame" );
    tabWidget->insertTab( _frame, QString("") );
    textLabel3 = new QLabel( _frame, "textLabel3" );
    textLabel3->setGeometry( QRect( 9, 33, 40, 20 ) );

    lineEdit5 = new QLineEdit( _frame, "lineEdit5" );
    lineEdit5->setGeometry( QRect( 69, 23, 160, 24 ) );

    lineEdit6 = new QLineEdit( _frame, "lineEdit6" );
    lineEdit6->setGeometry( QRect( 69, 53, 160, 24 ) );

    lineEdit7 = new QLineEdit( _frame, "lineEdit7" );
    lineEdit7->setGeometry( QRect( 69, 83, 160, 24 ) );

    lineEdit8 = new QLineEdit( _frame, "lineEdit8" );
    lineEdit8->setGeometry( QRect( 69, 113, 160, 24 ) );

    lineEdit9 = new QLineEdit( _frame, "lineEdit9" );
    lineEdit9->setGeometry( QRect( 69, 143, 160, 24 ) );

    lineEdit10 = new QLineEdit( _frame, "lineEdit10" );
    lineEdit10->setGeometry( QRect( 69, 173, 160, 24 ) );

    buttonInitFrame = new QPushButton( _frame, "buttonInitFrame" ) ;
    buttonInitFrame->setGeometry( QRect( 69, 210, 100, 30 ) );

    textLabel4 = new QLabel( _frame, "textLabel4" );
    textLabel4->setGeometry( QRect( 9, 63, 44, 20 ) );

    textLabel5 = new QLabel( _frame, "textLabel5" );
    textLabel5->setGeometry( QRect( 9, 93, 40, 20 ) );

    textLabel6 = new QLabel( _frame, "textLabel6" );
    textLabel6->setGeometry( QRect( 9, 123, 44, 20 ) );

    textLabel7 = new QLabel( _frame, "textLabel7" );
    textLabel7->setGeometry( QRect( 9, 153, 52, 20 ) );

    textLabel8 = new QLabel( _frame, "textLabel8" );
    textLabel8->setGeometry( QRect( 9, 183, 52, 20 ) );

    tabWidget->changeTab( _repartition,  "Color"  );
    tabWidget->changeTab( _frame,  "Frame" );
    tabWidget->changeTab( _selection,  "Selection" );

    lineEdit5->setText(  "-2.5"  );
    lineEdit6->setText(  "2.5"  );
    lineEdit7->setText(  "-2.5"  );
    lineEdit8->setText(  "2.5"  );
    lineEdit9->setText(  "10000"  );
    lineEdit10->setText(  "100"  );
    buttonInitFrame->setText( "init" ) ;

    textLabel3->setText(  "x min"  );
    textLabel4->setText(  "x max" );
    textLabel5->setText(  "y min"  );
    textLabel6->setText(  "y max"  );
    textLabel7->setText(  "iteration"  );
    textLabel8->setText(  "germs"  );

  resize( QSize(301,511) ) ;

 // Cration des menus.
 _fileMenu = new QPopupMenu(this) ;
 _fileMenu->insertItem("Save Image",this,SLOT(slotSaveImage()) ) ;
 _fileMenu->insertItem("Load Image",this,SLOT(slotChangeImage()) ) ;
 _fileMenu->insertItem("Load Palette",this,SLOT(slotLoadPalette()) ) ;
 _fileMenu->insertItem("Save IFS",this,SLOT(slotSaveIFS() ) ) ;
 _fileMenu->insertItem("Load IFS",this,SLOT(slotLoadIFS() ) ) ;
 //_fileMenu->insertItem("Load Matrix",this,SLOT(slotNeRienFaire()) ) ;
 //_fileMenu->insertItem("Save Matrix",this,SLOT(slotNeRienFaire()) ) ;
 _fileMenu->insertItem("export 3D...",this,SLOT(slotDialog3D()) ) ;
 _fileMenu->insertItem("Preferences",this,SLOT(slotPreferences()) ) ;
 _fileMenu->insertItem("&Quit",qApp,SLOT(quit()) ) ;
 //_fileMenu->setItemEnabled(1,false) ;
 //_fileMenu->setItemEnabled(2,false) ;
 //_fileMenu->setItemEnabled(3,false) ;
 //_fileMenu->setItemEnabled(4,false) ;


 //_transformationMenu = new QPopupMenu(this) ;
 //_transformationMenu->insertItem( "translation", TRANSFORMATION_ID_TRANSLATION ) ;
 //_transformationMenu->insertItem( "rotation", TRANSFORMATION_ID_ROTATION ) ;
 //_transformationMenu->insertItem( "scale", TRANSFORMATION_ID_SCALE ) ;
 //_transformationMenu->insertItem( "clipping", TRANSFORMATION_ID_CLIPPING ) ;
 //_transformationMenu->insertItem( "similarity", TRANSFORMATION_ID_SIMILARITY ) ;
 //_transformationMenu->insertItem( "undo", TRANSFORMATION_ID_ANNUL ) ;

 _sizemenu = new QPopupMenu(this) ;
 //_sizemenu->setCheckable(true) ;
 _sizemenu->insertItem( "128" , SIZE_ID_128 ) ;
 _sizemenu->insertItem( "256" , SIZE_ID_256 ) ;
 _sizemenu->insertItem( "512" , SIZE_ID_512 ) ;
 _sizemenu->insertItem( "1024" , SIZE_ID_1024 ) ;
 _sizemenu->insertItem( "2048" , SIZE_ID_2048 ) ;
 _sizemenu->insertItem( "4096" , SIZE_ID_4096 ) ;
 _sizemenu->insertItem( "8196" , SIZE_ID_8192 ) ;
 _sizemenu->insertItem( "16384" , SIZE_ID_16384 ) ;
 _sizemenu->insertItem( "32768" , SIZE_ID_32768 ) ;
 _sizemenu->insertItem( "65536" , SIZE_ID_65536 ) ;
 _sizemenu->setItemEnabled(SIZE_ID_4096,false) ;
 _sizemenu->setItemEnabled(SIZE_ID_8192,false) ;
 _sizemenu->setItemEnabled(SIZE_ID_16384,false) ;
 _sizemenu->setItemEnabled(SIZE_ID_32768,false) ;
 _sizemenu->setItemEnabled(SIZE_ID_65536,false) ;

 _actionMenu = new QPopupMenu(this) ;
 _actionMenu->insertItem("calculate",this,SLOT(slotCalculate()),Qt::Key_F9) ;
 _actionMenu->insertItem("draw",this,SLOT(slotDrawMatrixF10()),Qt::Key_F10) ;
 _actionMenu->setItemEnabled(1,false) ;

 _effectMenu = new QPopupMenu(this) ;
 _effectMenu->insertItem("none",EFFECT_ID_NONE ) ;
 _effectMenu->insertItem("slip",EFFECT_ID_SLIP ) ;
 _effectMenu->insertItem("complex",EFFECT_ID_COMPLEX ) ;
 _effectMenu->insertItem("Apophysis 1",EFFECT_ID_V1 ) ;
 _effectMenu->insertItem("Apophysis 2",EFFECT_ID_V2 ) ;
 _effectMenu->insertItem("Apophysis 3",EFFECT_ID_V3 ) ;
 _effectMenu->insertItem("Apophysis 4",EFFECT_ID_V4 ) ;
 _effectMenu->insertItem("Apophysis 5",EFFECT_ID_V5 ) ;
 _effectMenu->insertItem("Apophysis 6",EFFECT_ID_V6 ) ;
 _effectMenu->insertItem("Apophysis 7",EFFECT_ID_V7 ) ;
 _effectMenu->insertItem("Apophysis 8",EFFECT_ID_V8 ) ;
 _effectMenu->insertItem("Apophysis 9",EFFECT_ID_V9 ) ;
 _effectMenu->insertItem("Apophysis 10",EFFECT_ID_V10 ) ;
 _effectMenu->insertItem("Apophysis 11",EFFECT_ID_V11 ) ;
 _effectMenu->insertItem("Apophysis 12",EFFECT_ID_V12 ) ;
 _effectMenu->insertItem("Apophysis 13",EFFECT_ID_V13 ) ;
 _effectMenu->insertItem("Qifs 1",EFFECT_ID_W1 ) ;
 _effectMenu->insertItem("Qifs 2",EFFECT_ID_W2 ) ;
 _effectMenu->insertItem("Qifs 3",EFFECT_ID_W3 ) ;
 _effectMenu->insertItem("Qifs 4",EFFECT_ID_W4 ) ;
 _effectMenu->insertItem("Qifs 5",EFFECT_ID_W5 ) ;
 _effectMenu->insertItem("Qifs 6",EFFECT_ID_W6 ) ;
 _effectMenu->insertItem("Qifs 7",EFFECT_ID_W7 ) ;
 _effectMenu->insertItem("Qifs 8",EFFECT_ID_W8 ) ;
 _effectMenu->insertItem("Qifs 9",EFFECT_ID_W9 ) ;
 _effectMenu->insertItem("Qifs 10",EFFECT_ID_W10 ) ;
 _effectMenu->insertItem("Qifs 11",EFFECT_ID_W11 ) ;
 _effectMenu->insertItem("Qifs 12",EFFECT_ID_W12 ) ;
 _effectMenu->insertItem("Qifs 13",EFFECT_ID_W13 ) ;
 _effectMenu->setItemEnabled(EFFECT_ID_COMPLEX,false) ;

 _effectColorMenu = new QPopupMenu(this) ;
 _effectColorMenu->insertItem("none",EFFECT_COLOR_ID_NONE ) ;
 _effectColorMenu->insertItem("log",EFFECT_COLOR_ID_LOG ) ;
 _effectColorMenu->insertItem("gamma",EFFECT_COLOR_ID_GAMMA ) ;
 _effectColorMenu->insertItem("relief",EFFECT_COLOR_ID_RELIEF ) ;
 _effectColorMenu->insertItem("contrast",EFFECT_COLOR_ID_CONTRAST ) ;

 _aboutMenu = new QPopupMenu(this) ;
 _aboutMenu->insertItem("&About qifs" , this , SLOT( slotAbout() ) ) ;
 _aboutMenu->insertItem("About Qt" , this , SLOT( slotAboutQt() ) ) ;

 _menubar = new QMenuBar( this ) ;
 _menubar->insertItem("&File" , _fileMenu ) ;
 //_menubar->insertItem("&Op" , _transformationMenu ) ;
 _menubar->insertItem("&Action" , _actionMenu ) ;
 _menubar->insertItem("&Size" , _sizemenu ) ;
 _menubar->insertItem("&Effect" , _effectMenu ) ;
 _menubar->insertItem("E&ffect Color" , _effectColorMenu ) ;
 _menubar->insertSeparator() ;
 _menubar->insertItem("About" , _aboutMenu ) ;
 _statusbar = new QStatusBar( this, "_statusbar" ) ;
 _labelInfo = new QLabel( this, "_labelInfo" ) ;
 _labelInfo->setText("0 s") ;
 _statusbar->addWidget(_labelInfo,100) ;

 //QString filename = QFileDialog::getOpenFileName(".","*.bmp",this) ;
 nomImage = QFileDialog::getOpenFileName("images/","*.bmp",this) ;
 if (!nomImage.isEmpty())
	{
	 QPixmap temp ;
	 temp.load(nomImage,"BMP") ;
	 _conteneurImage = new conteneurImage( temp) ;
	 _conteneurImage->show() ;
	}
	else
	{
	 _conteneurImage = new conteneurImage() ;
	 _conteneurImage->setGeometry( 5 , 5 , 500 , 500 ) ;
	 _conteneurImage->show() ;
	}

 // ***************
 // Les fentres pour les effets de couleurs
 _wEffectColor = new wEffectColor(0,"_wEffectColor",0) ;
 _wEffectColorGamma = new wEffectColorGamma(0,"_wEffectColorGamma",0) ;
 _wEffectColorRelief = new wEffectColorRelief(0,"_wEffectColorRelief",0) ;
 _wEffectColorLog = new wEffectColorLog(0,"_wEffectColorLog",0) ;
 _wEffectColorContrast = new wEffectColorContrast(0,"_wEffectColorContrast",0) ;
 _wEffectColorPtr = _wEffectColor ;
 // pile pour les paramtres des effets de couleurs
 _paramEffectColor = new sparam(6) ;

 // ***************
 // Les fentres pour les effets sur les functions affines
 _wEffectFunction = new wEffectFunction(0,"_wEffectFunction",0 ) ;
 _wEffectFunctionSlip = new wEffectFunctionSlip(0,"_wEffectFunctionSlip",0 ) ;
 _wEffectFunctionApophysisNew = new wEffectFunctionApophysisNew(0,"-wEffectFunctionApophysisNew",0 ) ;
 _wEffectFunctionPtr = _wEffectFunction ;
 // pile pour les paramtres des effets sur les functions affines
 _paramEffectFunction = new sparam(2) ;

 QObject::connect(_sizemenu,SIGNAL(activated(int)),this,SLOT(slotSizeChanged(int))) ;
 QObject::connect(_effectMenu,SIGNAL(activated(int)),this,SLOT(slotEffectChanged(int))) ;
 QObject::connect(_effectColorMenu,SIGNAL(activated(int)),this,SLOT(slotEffectColorChanged(int))) ;
 QObject::connect(_conteneurImage,SIGNAL(signalIFSchanged(paralleVector*,int,int)),
 			this,SLOT(changeIFS(paralleVector*,int,int)) ) ;
 QObject::connect(_conteneurImage,SIGNAL(signalCalculate()),
 			this,SLOT(slotCalculate()) ) ;

 QObject::connect( _conteneurPlanche,SIGNAL(signalRepartitionMinMaxChanged(int*,int,int)),
 			this,SLOT(slotRepartitionMinMaxChanged(int*,int,int))) ;
 QObject::connect( _conteneurPlanche,SIGNAL(signalFrameChanged(double,double,double,double)),
 			this,SLOT(slotFrameChanged( double,double,double,double))) ;
QObject::connect( _conteneurPlanche,SIGNAL(signalDelay(double)),this,SLOT(slotDelay(double)) ) ;

 QObject::connect( _dialogPalette,SIGNAL(fileSelected(const QString &)),
 			this,SLOT(slotSetPalette(const QString &))) ;
 QObject::connect( _repartition,SIGNAL(signalDrawRepartitionZoomed(int ,int )),
 			this,SLOT(slotDrawRepartitionZoomed(int,int)) ) ;


 QObject::connect( lineEdit5,SIGNAL(lostFocus()),this,SLOT(slotCoordinateChanged()) ) ;
 QObject::connect( lineEdit6,SIGNAL(lostFocus()),this,SLOT(slotCoordinateChanged()) ) ;
 QObject::connect( lineEdit7,SIGNAL(lostFocus()),this,SLOT(slotCoordinateChanged()) ) ;
 QObject::connect( lineEdit8,SIGNAL(lostFocus()),this,SLOT(slotCoordinateChanged()) ) ;
 QObject::connect( lineEdit9,SIGNAL(lostFocus()),this,SLOT(slotIterationAndGermsChanged()) ) ;
 QObject::connect( lineEdit10,SIGNAL(lostFocus()),this,SLOT(slotIterationAndGermsChanged()) ) ;
 //QObject::connect( lineEdit10,SIGNAL(lostFocus()),this,SLOT(slotKappaChanged()) ) ;
 //QObject::connect( lineEdit10,SIGNAL(returnPressed()),this,SLOT(slotKappaChanged()) ) ;
 QObject::connect( buttonInitFrame,SIGNAL(clicked()),this,SLOT(slotButtonInitFrame()) ) ;
 QObject::connect( _repartition,SIGNAL(signalParameterColorationChanged()),
 			this,SLOT(slotParameterColorationChanged()) ) ;

 QObject::connect( _wEffectColorGamma,SIGNAL(signalDraw()),
			this,SLOT(slotDrawMatrixF10()) ) ;
 QObject::connect( _wEffectColorRelief,SIGNAL(signalDraw()),
			this,SLOT(slotDrawMatrixF10()) ) ;
 QObject::connect( _wEffectColorLog,SIGNAL(signalDraw()),
			this,SLOT(slotDrawMatrixF10()) ) ;
 QObject::connect( _wEffectColorContrast,SIGNAL(signalDraw()),
			this,SLOT(slotDrawMatrixF10()) ) ;

 QObject::connect( _wEffectFunctionSlip,SIGNAL(signalCalculate()),
			this,SLOT(slotCalculate()) ) ;
 QObject::connect( _wEffectFunctionApophysisNew,SIGNAL(signalCalculate()),
			this,SLOT(slotCalculate()) ) ;


 show() ;
}

fenetrePrincipale :: ~fenetrePrincipale()
{
 delete _conteneurImage ;
 delete _conteneurPlanche ;
 delete _paramEffectColor ;
 delete _wEffectColor ;
 delete _wEffectColorGamma ;
 delete _wEffectColorRelief ;
 delete _wEffectColorLog ;
 delete _wEffectColorContrast ;

 delete _wEffectFunction ;
 delete _wEffectFunctionSlip ;
 delete _wEffectFunctionApophysisNew ;
 delete _paramEffectFunction ;
}

void fenetrePrincipale :: slotChangeImage()
{
 QString filename = QFileDialog::getOpenFileName("images","*.bmp",this) ;
 if (!filename.isEmpty())
	{
	 QPixmap temp ;
	 temp.load(filename,"BMP") ;
	 _conteneurImage->imageChanged( &temp ) ;
	}
}

void fenetrePrincipale :: slotRepartitionMinMaxChanged(int* a,int m,int M)
{
 _repartition->drawRepartition(a) ;
 _repartition->setMinMax(m,M) ;
}

void fenetrePrincipale :: slotParameterColorationChanged()
{
 _repartition->getParameterColoration(&_parameterColoration) ;
 _conteneurPlanche->changeParameterColoration(&_parameterColoration) ;
 //if (drawMatrixWithRepartitionColoration) _conteneurPlanche->drawMatrix() ;
}


void fenetrePrincipale :: slotDrawMatrixF10()
{
 slotParameterColorationChanged() ;
 slotParametersEffectChanged() ;
 slotParametersEffectColorChanged() ;
 _conteneurPlanche->drawMatrix() ;
}

void fenetrePrincipale :: slotDrawRepartitionZoomed(int ml,int Ml)
{
 _conteneurPlanche->getRepartition(repartitionZoom,ml,Ml) ;
 _repartition->drawRepartition(repartitionZoom) ;
 if (drawMatrixWithRepartitionColoration) _conteneurPlanche->drawMatrix() ;
}

void fenetrePrincipale :: slotSizeChanged(int a)
{
 int sizeLocal ;

 sizeLocal = 1 << (a+7) ;
 _conteneurPlanche->changeSizeMatrix(sizeLocal) ;
}

void fenetrePrincipale :: slotCoordinateChanged()
{
 double xm,xM,ym,yM ;
 bool ok ;

 xm = (lineEdit5->text()).toDouble(&ok) ; // x min
 if (not(ok))
	{
	 xm = -5.0 ;
	 lineEdit5->setText("-5.0") ;
	}
 xM = (lineEdit6->text()).toDouble(&ok) ; // x max
 if (not(ok))
	{
	 xM = 5.0 ;
	 lineEdit6->setText("5.0") ;
	}
 ym = (lineEdit7->text()).toDouble(&ok) ; // y min
 if (not(ok))
	{
	 ym = -5.0 ;
	 lineEdit7->setText("-5.0") ;
	}
 yM = (lineEdit8->text()).toDouble(&ok) ; // y max
 if (not(ok))
	{
	 xM = 5.0 ;
	 lineEdit8->setText("5.0") ;
	}
 _conteneurPlanche->changeCoordinate(xm,xM,ym,yM) ;
}

void fenetrePrincipale :: slotButtonInitFrame()
{
 QString nb ;
 double xm,xM,ym,yM ;

 xm = -5.0 ;
 xM = 5.0 ;
 ym = -5.0 ;
 yM = 5.0 ;
 lineEdit5->setText( nb.setNum( xm,'g',16)  );
 lineEdit6->setText( nb.setNum( xM,'g',16)  );
 lineEdit7->setText( nb.setNum( ym,'g',16)  );
 lineEdit8->setText( nb.setNum( yM,'g',16)  );

 _conteneurPlanche->changeCoordinate(xm,xM,ym,yM) ;
}

void fenetrePrincipale :: slotFrameChanged(double a,double b,double c,double d)
{
 QString nb ;

 lineEdit5->setText( nb.setNum( a,'g',16)  );
 lineEdit6->setText( nb.setNum( b,'g',16)  );
 lineEdit7->setText( nb.setNum( c,'g',16)  );
 lineEdit8->setText( nb.setNum( d,'g',16)  );
}

void fenetrePrincipale :: changeIFS(paralleVector* p,int h,int w)
{
 _conteneurPlanche->changeIFS(p,h,w) ;
}

void fenetrePrincipale :: slotCalculate()
{
 double xm,xM,ym,yM ;
 int nb,nb_germs ;
 bool ok ;

 xm = (lineEdit5->text()).toDouble(&ok) ; // x min
 if (not(ok))
	{
	 xm = -5.0 ;
	 lineEdit5->setText("-5.0") ;
	}
 xM = (lineEdit6->text()).toDouble(&ok) ; // x max
 if (not(ok))
	{
	 xM = 5.0 ;
	 lineEdit6->setText("5.0") ;
	}
 ym = (lineEdit7->text()).toDouble(&ok) ; // y min
 if (not(ok))
	{
	 ym = -5.0 ;
	 lineEdit7->setText("-5.0") ;
	}
 yM = (lineEdit8->text()).toDouble(&ok) ; // y max
 if (not(ok))
	{
	 xM = 5.0 ;
	 lineEdit8->setText("5.0") ;
	}
 nb = (lineEdit9->text()).toLong(&ok) ;
 if (not(ok))
 	{
	 nb = 10000 ;
	 lineEdit9->setText("10000") ;
	}
 nb_germs = (lineEdit10->text()).toLong(&ok) ;
 if (not(ok))
 	{
	 nb_germs = 100 ;
	 lineEdit9->setText("100") ;
	}
 slotParametersEffectChanged() ;
 _conteneurPlanche->calculateF9(xm,xM,ym,yM,nb,nb_germs) ;
}

void fenetrePrincipale :: slotIterationAndGermsChanged()
{
 int nb,nb_germs ;
 bool ok ;

 nb = (lineEdit9->text()).toLong(&ok) ;
 if (not(ok))
 	{
	 nb = 10000 ;
	 lineEdit9->setText("10000") ;
	}
 nb_germs = (lineEdit10->text()).toLong(&ok) ;
 if (not(ok))
 	{
	 nb_germs = 100 ;
	 lineEdit9->setText("100") ;
	}
 _conteneurPlanche->changeIterationAndGerms(nb,nb_germs) ;
}

/*
void fenetrePrincipale :: slotKappaChanged()
{
 double nb ;
 bool ok ;

 nb = (lineEdit10->text()).toDouble(&ok) ;
 if (not(ok))
 	{
	 nb = 1.0 ;
	 lineEdit9->setText("1.0") ;
	}
 _conteneurPlanche->changeKappa(nb) ;
}*/

void fenetrePrincipale :: slotSetPalette(const QString & f)
{
 pale = f ;
 //cout << pale << endl ;
}

void fenetrePrincipale :: slotSaveImage()
{
 QString filename = QFileDialog::getSaveFileName(".","*.txt",this) ;
 if (!filename.isEmpty()) _conteneurPlanche->saveImage(filename) ;
 	else cout << " error of open file !" << filename << endl ;
}

void fenetrePrincipale :: slotLoadPalette()
{
 int res ;

 //QString filename = dialogPalette::getOpenFileName(".","*.txt",this) ;
 res = _dialogPalette->exec() ;
 if ((res == QDialog::Accepted) && (!pale.isEmpty()))
	{
	 _conteneurPlanche->loadPalette(pale) ;
	 changePaletteForRepartition() ;
	}

}

void fenetrePrincipale :: slotDialog3D()
{
 QString nom ;
 dialog3D* myd ;
 double xmin3d,xmax3d,ymin3d,ymax3d,zmin3d,zmax3d ;
 int f,ta ;

 myd = new dialog3D() ;
 int ret = myd->exec() ;
 if (ret == QDialog::Accepted)
	{
	 nom = myd->get3D(&xmin3d,&xmax3d,&ymin3d,&ymax3d,&zmin3d,&zmax3d,&f,&ta) ;
	 _conteneurPlanche->draw3D(xmin3d,xmax3d,ymin3d,ymax3d,zmin3d,zmax3d,f,ta,nom) ;
	}
 delete myd ;
}

void fenetrePrincipale :: slotParametersEffectChanged()
{
 _wEffectFunctionPtr->getParameters(_paramEffectFunction) ;
 _conteneurPlanche->changeParameterEffect(_paramEffectFunction) ;
}

void fenetrePrincipale :: slotEffectChanged(int c)
{
 bool aff ;

 _wEffectFunctionPtr->hide() ;
 switch(c)
	{
	 case EFFECT_ID_NONE    : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_SLIP    : _wEffectFunctionPtr = _wEffectFunctionSlip ; aff = true ; break ;
	 //case EFFECT_ID_COMPLEX : _wEffectFunctionPtr = _wEffectFunctionComplex ; aff = true ; break ;
	 case EFFECT_ID_V1      : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V2      : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V3      : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V4      : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V5      : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V6      : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V7      : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V8      : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V9      : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V10     : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V11     : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V12     : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_V13     : _wEffectFunctionPtr = _wEffectFunction ; aff = false ; break ;
	 case EFFECT_ID_W1      : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W2      : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W3      : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W4      : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W5      : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W6      : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W7      : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W8      : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W9      : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W10     : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W11     : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W12     : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 case EFFECT_ID_W13     : _wEffectFunctionPtr = _wEffectFunctionApophysisNew ; aff = true ; break ;
	 default : _wEffectFunctionPtr = _wEffectFunction ; aff = false ;
	}

 if (aff) _wEffectFunctionPtr->show() ;
 slotParametersEffectChanged() ;
 _conteneurPlanche->changeEffect(c) ;
}

void fenetrePrincipale :: slotParametersEffectColorChanged()
{
 _wEffectColorPtr->getParameters(_paramEffectColor) ;
 _conteneurPlanche->changeParameterEffectColor(_paramEffectColor) ;
}

void fenetrePrincipale :: slotEffectColorChanged(int c)
{
 //cout << " c =  " <<  c << endl ;
 _wEffectColorPtr->hide() ;
 if (c == EFFECT_COLOR_ID_NONE)
	{
	 _wEffectColorPtr = _wEffectColor ;
	 // inutile de la montrer :-)
	}
	else
	{
	 switch(c)
		{
		 case EFFECT_COLOR_ID_LOG : _wEffectColorPtr = _wEffectColorLog ; break ;
		 case EFFECT_COLOR_ID_GAMMA : _wEffectColorPtr = _wEffectColorGamma ; break ;
		 case EFFECT_COLOR_ID_RELIEF : _wEffectColorPtr = _wEffectColorRelief ; break ;
		 case EFFECT_COLOR_ID_CONTRAST : _wEffectColorPtr = _wEffectColorContrast ; break ;
		}
	 _wEffectColorPtr->show() ;
	 slotParametersEffectColorChanged() ;
	}
 _conteneurPlanche->changeEffectColor(c) ;
}

void fenetrePrincipale :: slotSaveIFS()
{
 QString filename = QFileDialog::getSaveFileName("ifs","*.ifs",this,"save file dialog","choose a name" ) ;
 if (!filename.isEmpty()) _conteneurImage->saveIFS(filename) ;
 	else cout << " error of open file !" << filename << endl ;
}

void fenetrePrincipale :: slotLoadIFS()
{
 QString filename = QFileDialog::getOpenFileName("ifs","*.ifs",this,"open file dialog","Choose a IFS file") ;
 if (!filename.isEmpty()) _conteneurImage->loadIFS(filename) ;
 	else cout << " error of open file !" << filename << endl ;
}

void fenetrePrincipale :: slotDelay(double dt)
{
 QString nb ;

 _labelInfo->setText(nb.setNum( dt,'g',16) + " s" ) ;
}

void fenetrePrincipale :: slotPreferences()
{
 dialogAlgorithm* myd ;
 int ret,algo ;

 myd = new dialogAlgorithm() ;
 ret = myd->exec() ;
 algo = myd->getAlgorithm() ;
 _conteneurPlanche->changeAlgorithmColoration(algo) ;
 delete myd ;
}

void fenetrePrincipale :: paintEvent( QPaintEvent* event )
{
 //cout << " +" << endl ;
 //bitBlt( tab , 9 , 3 , &_bufferRepartitionGlobal ) ;
 //bitBlt( this , 10 , 170 , _iimagePalette ) ;
}

void fenetrePrincipale :: resizeEvent( QResizeEvent* event)
{

}

void fenetrePrincipale :: slotAbout()
{

 QMessageBox::information( this , "A Propos de qifs",
 				  "august 22 2006\n"
				  "Copyright 2006 - Raphi \n"
				  "raphael.pasquier@free.fr\n"
				  "Licence GPL v2") ;

}

void fenetrePrincipale :: slotAboutQt()
{
 QMessageBox::aboutQt( this , "A Propos de Qt" ) ;
}

void fenetrePrincipale :: slotNeRienFaire()
{
}











