//#include <iostream>
//#include <fstream>
//using namespace std ;

#include <qvariant.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qbuttongroup.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qcombobox.h>

#include "constants.h"
#include "dialogAlgorithm.h"


dialogAlgorithm :: dialogAlgorithm( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{

    setName( "dialog Algorithme" );
    setSizeGripEnabled( TRUE );


    buttonGroup1 = new QButtonGroup( this, "buttonGroup1" );
    buttonGroup1->setGeometry( QRect( 30, 30, 160, 100 ) );
    buttonGroup1->setRadioButtonExclusive(true) ;

    radioButton1 = new QRadioButton( buttonGroup1, "radioButton1" );
    radioButton1->setGeometry( QRect( 20, 30, 106, 22 ) );
    radioButton1->setChecked(true) ;

    radioButton2 = new QRadioButton( buttonGroup1, "radioButton2" );
    radioButton2->setGeometry( QRect( 20, 60, 80, 22 ) );


    setCaption(  "Algorithm"  );
    buttonGroup1->setTitle(  "Algorithm"  );
    radioButton1->setText(  "repartition"  );
    radioButton2->setText(  "sigma"  );

    resize( QSize(270, 170).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );


}

/*
 *  Destroys the object and frees any allocated resources
 */
dialogAlgorithm::~dialogAlgorithm()
{
    // no need to delete child widgets, Qt does it all for us
}

int dialogAlgorithm :: getAlgorithm()
{
 if (radioButton1->isChecked()) return (ALGORITHM_COLORATION_ID_REPARTITION) ;
	else return(ALGORITHM_COLORATION_ID_SIGMA) ;
}







