
#ifndef DIALOGPALETTE_H
#define DIALOGPALETTE_H

//#include <qvariant.h>
#include <qfiledialog.h>
#include <qpixmap.h>
#include <qwidget.h>

class dialogPalette : public QFileDialog
{
    Q_OBJECT

 public:
    dialogPalette( const QString & dirName, const QString & filter = QString::null, QWidget* parent = 0, const char* name = 0, bool modal = FALSE );
    ~dialogPalette();

 private slots :
   void printPalette( const QString & ) ;

 protected :
  virtual void paintEvent( QPaintEvent* ) ;

 private :
  QWidget* _imagePalette ;
  QPixmap* _bufferImagePalette ;

};

#endif // DIALOGPALETTE_H
