#include <qlabel.h>
#include <qlineedit.h>
#include <qradiobutton.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>


#include "sparam.h"
#include "wEffectColorContrast.h"


wEffectColorContrast :: wEffectColorContrast( QWidget* parent=0,const char* name=0, WFlags f=0 ) : wEffectColor(parent,name,f)
{
    lineEdit1 = new QLineEdit( this, "lineEdit1" );
    lineEdit1->setGeometry( QRect( 90, 10, 80, 24 ) );

    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setGeometry( QRect( 20, 20, 59, 20 ) );

    lineEdit2 = new QLineEdit( this, "lineEdit2" );
    lineEdit2->setGeometry( QRect( 90, 40, 80, 24 ) );

    textLabel2 = new QLabel( this, "textLabel2" );
    textLabel2->setGeometry( QRect( 20, 50, 50, 20 ) );

    lineEdit16 = new QLineEdit( this, "lineEdit16" );
    lineEdit16->setGeometry( QRect( 90, 70, 80, 24 ) );

    textLabel1_2 = new QLabel( this, "textLabel1_2" );
    textLabel1_2->setGeometry( QRect( 20, 80, 60, 20 ) );

    textLabel1_3 = new QLabel( this, "textLabel1_3" );
    textLabel1_3->setGeometry( QRect( 20, 105, 113, 20 ) );

    /*
    buttonGroup3 = new QButtonGroup( this, "buttonGroup3" );
    buttonGroup3->setGeometry( QRect( 20, 110, 150, 130 ) );
    buttonGroup3->setExclusive(true) ;

    radioButton1 = new QRadioButton( buttonGroup3, "radioButton1" );
    radioButton1->setGeometry( QRect( 10, 30, 106, 22 ) );
    radioButton1->setChecked(true) ;

    radioButton2 = new QRadioButton( buttonGroup3, "radioButton2" );
    radioButton2->setGeometry( QRect( 10, 60, 70, 22 ) );

    radioButton3 = new QRadioButton( buttonGroup3, "radioButton3" );
    radioButton3->setGeometry( QRect( 10, 90, 70, 22 ) );

    pushButton1 = new QPushButton( this, "pushButton1" );
    pushButton1->setGeometry( QRect( 40, 250, 100, 30 ) );
    */

    //setGeometry(300,200,187, 305) ;
    setGeometry(300,200,187, 135) ;

    textLabel1->setText(  "intensity"  );
    textLabel2->setText(  "Theta" ) ;
    textLabel1_2->setText(  "phi" ) ;
    textLabel1_3->setText(  "type F10 to draw" ) ;
    //buttonGroup3->setTitle(  "z" ) ;
    //radioButton1->setText(  "linear"  );
    //radioButton2->setText(  "log" ) ;
    //radioButton3->setText(  "log log"  );
    //pushButton1->setText(  "validate"  );
    lineEdit1->setText("0.2") ;
    lineEdit2->setText("45") ;
    lineEdit16->setText("45") ;


 QObject::connect( lineEdit1,SIGNAL(lostFocus()),this,SLOT(slotParamatersChanged()) ) ;
 QObject::connect( lineEdit2,SIGNAL(lostFocus()),this,SLOT(slotParamatersChanged()) ) ;
 QObject::connect( lineEdit16,SIGNAL(lostFocus()),this,SLOT(slotParamatersChanged()) ) ;
 //QObject::connect( radioButton1,SIGNAL(clicked()),this,SLOT(slotParamatersChanged()) ) ;
 //QObject::connect( radioButton2,SIGNAL(clicked()),this,SLOT(slotParamatersChanged()) ) ;
 //QObject::connect( radioButton3,SIGNAL(clicked()),this,SLOT(slotParamatersChanged()) ) ;
 //QObject::connect( pushButton1,SIGNAL(clicked()),this,SLOT(slotParamatersChanged()) ) ;
}

wEffectColorContrast :: ~wEffectColorContrast()
{
}

void wEffectColorContrast :: getParameters(sparam* p)
{
 (*p)[0] = lineEdit1->text() ;
 (*p)[1] = lineEdit2->text() ;
 (*p)[2] = lineEdit16->text() ;

 //if (radioButton1->isChecked()) (*p)[3] = "linear" ;
 // else if (radioButton2->isChecked()) (*p)[3] = "log" ; else (*p)[3] = "loglog" ;
}

void wEffectColorContrast :: slotParamatersChanged()
{
 emit signalParamatersChanged() ;
}


