#include <qlabel.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>


#include "sparam.h"
#include "wEffectColorLog.h"


wEffectColorLog :: wEffectColorLog( QWidget* parent=0,const char* name=0, WFlags f=0 ) : wEffectColor(parent,name,f)
{
    slider1 = new QSlider(0,100,1,0,Horizontal,this,"slider1") ;
    slider1->setGeometry( QRect(20,20,84,20 ) ) ;
    //slider1->setOrientation(Horizontal) ;

    checkBox2 = new QCheckBox(this,"checkBox2" ) ;
    checkBox2->setGeometry( QRect( 20,50,80,22) ) ;
    checkBox2->setText("inverse") ;

    textLabel1 = new QLabel(this,"textLabel1") ;
    textLabel1->setGeometry( QRect( 10,80,113,20 ) ) ;
    textLabel1->setText("type F10 to draw") ;

    //pushButton1 = new QPushButton( this, "pushButton1" );
    //pushButton1->setGeometry( QRect( 20, 120, 100, 30 ) );
    //resize( QSize(148, 164).expandedTo(minimumSizeHint()) );
    setGeometry(400,200,134,115) ;

}

wEffectColorLog :: ~wEffectColorLog()
{
}

void wEffectColorLog :: getParameters(sparam* p)
{
 QString nb ;

 //(*p)[0] = lineEdit1->text() ;
 (*p)[0] = nb.setNum( slider1->value()*0.01,'g',16) ;
 if (checkBox2->isChecked()) (*p)[1] = "1" ; else (*p)[1] = "0" ;
}

void wEffectColorLog :: slotParamatersChanged()
{
 emit signalParamatersChanged() ;
}


